searchNodes=[{"doc":"Your gateway to the Census API.Use query/1 to get data from the Census.iex&gt; q = PS2.API.Query.new(collection: &quot;character_name&quot;) ...&gt; |&gt; PS2.API.QueryBuilder.term(&quot;name.first_lower&quot;, &quot;snowful&quot;) %PS2.API.Query{ collection: &quot;character_name&quot;, joins: [], params: %{&quot;name.first_lower&quot; =&gt; {&quot;&quot;, &quot;snowful&quot;}}, sort: nil, tree: nil } iex&gt; PS2.API.query(q) {:ok, %PS2.API.QueryResult{ data: [ %{ &quot;character_id&quot; =&gt; &quot;5428713425545165425&quot;, &quot;name&quot; =&gt; %{&quot;first&quot; =&gt; &quot;Snowful&quot;, &quot;first_lower&quot; =&gt; &quot;snowful&quot;} } ], returned: 1 } }","ref":"PS2.API.html","title":"PS2.API","type":"module"},{"doc":"Encodes a Query struct into an API-ready string.","ref":"PS2.API.html#encode/1","title":"PS2.API.encode/1","type":"function"},{"doc":"View a list of all the public API collections and their resolves.","ref":"PS2.API.html#get_collections/0","title":"PS2.API.get_collections/0","type":"function"},{"doc":"Gets the image binary for a .png.","ref":"PS2.API.html#get_image/1","title":"PS2.API.get_image/1","type":"function"},{"doc":"Gets the image link.","ref":"PS2.API.html#get_image_url/1","title":"PS2.API.get_image_url/1","type":"function"},{"doc":"Sends query to the API and returns a list of results if successful.","ref":"PS2.API.html#query/1","title":"PS2.API.query/1","type":"function"},{"doc":"Sends query to the API and returns the first result if successful.","ref":"PS2.API.html#query_one/1","title":"PS2.API.query_one/1","type":"function"},{"doc":"","ref":"PS2.API.Collection.SingleCharacterByID.html","title":"PS2.API.Collection.SingleCharacterByID","type":"module"},{"doc":"A data structure representing a join on an API query. Create a join using %PS2.API.Join{} or the new/0 or new/1 functions.","ref":"PS2.API.Join.html","title":"PS2.API.Join","type":"module"},{"doc":"","ref":"PS2.API.Join.html#new/0","title":"PS2.API.Join.new/0","type":"function"},{"doc":"","ref":"PS2.API.Join.html#new/1","title":"PS2.API.Join.new/1","type":"function"},{"doc":"","ref":"PS2.API.Join.html#t:opts/0","title":"PS2.API.Join.opts/0","type":"type"},{"doc":"","ref":"PS2.API.Join.html#t:t/0","title":"PS2.API.Join.t/0","type":"type"},{"doc":"A data structure representing an API query. Create a struct using %PS2.API.Query{} or the new/0 or new/1 functions.","ref":"PS2.API.Query.html","title":"PS2.API.Query","type":"module"},{"doc":"","ref":"PS2.API.Query.html#new/0","title":"PS2.API.Query.new/0","type":"function"},{"doc":"","ref":"PS2.API.Query.html#new/1","title":"PS2.API.Query.new/1","type":"function"},{"doc":"","ref":"PS2.API.Query.html#t:opts/0","title":"PS2.API.Query.opts/0","type":"type"},{"doc":"The key of a term is the field name, and the value is the sort direction. Set the value to nil for the default sort direction.","ref":"PS2.API.Query.html#t:sort_terms/0","title":"PS2.API.Query.sort_terms/0","type":"type"},{"doc":"","ref":"PS2.API.Query.html#t:t/0","title":"PS2.API.Query.t/0","type":"type"},{"doc":"A module for creating Census API queries in a clean manner via pipelines.Exampleiex&gt; import PS2.API.QueryBuilder PS2.API.QueryBuilder iex&gt; alias PS2.API.Query PS2.API.Query iex&gt; query = Query.new(collection: &quot;character&quot;) ...&gt; |&gt; term(&quot;character_id&quot;, &quot;5428011263335537297&quot;) ...&gt; |&gt; show([&quot;character_id&quot;, &quot;name.en&quot;, &quot;faction_id&quot;]) ...&gt; |&gt; limit(3) ...&gt; |&gt; exact_match_first(true) %PS2.API.Query{ collection: &quot;character&quot;, joins: [], sort: nil, params: %{ &quot;c:exactMatchFirst&quot; =&gt; true, &quot;c:limit&quot; =&gt; 3, &quot;c:show&quot; =&gt; &quot;character_id,name.en,faction_id&quot;, &quot;character_id&quot; =&gt; {&quot;&quot;, &quot;5428011263335537297&quot;} }, tree: nil } iex&gt; PS2.API.encode query {:ok, &quot;character?c:exactMatchFirst=true&amp;c:limit=3&amp;c:show=character_id,name.en,faction_id&amp;character_id=5428011263335537297&quot;}You can then send the query to the api using PS2.API.query/1.Search ModifiersThe Census API provides search modifiers for filtering query results. You can pass an atom as the third parameter in term/4 representing one of these search modifiers. The recognized atoms are the following::greater_than :greater_than_or_equal :less_than :less_than_or_equal :starts_with :contains :notFor example: term(query_or_join, &quot;name.first_lower&quot;, &quot;wrel&quot;, :starts_with)Joining QueriesYou can use Joins to gather data from multiple collections within one query, like so:import PS2.API.QueryBuilder alias PS2.API.{Query, Join} online_status_join = # Note we could use Join.new(collection: &quot;characters_online_status&quot;, show: &quot;online_status&quot; ...) %Join{} |&gt; collection(&quot;characters_online_status&quot;) |&gt; show(&quot;online_status&quot;) |&gt; inject_at(&quot;online_status&quot;) |&gt; list(true) query = %Query{} |&gt; collection(&quot;character&quot;) |&gt; join(online_status_join)When the query q is sent to the API, the result with have an extra field, &quot;online_status&quot;, which contains the result of the Join (the player's online status.)You can create as many adjacent Joins as you'd like by repeatedly piping a query through QueryBuilder.join/2. You can also nest Joins via QueryBuilder.join/2 when you pass a Join as the first argument instead of a Query.import PS2.API.QueryBuilder alias PS2.API.{Query, Join} char_achieve_join = Join.new(collection: &quot;characters_achievement&quot;, on: &quot;character_id&quot;) char_name_join = Join.new(collection: &quot;character_name&quot;, on: &quot;character_id&quot;, inject_at: &quot;c_name&quot;) online_status_join = Join.new(collection: &quot;characters_online_status&quot;) |&gt; join(char_name_join) |&gt; join(char_achieve_join) query = %Query{} |&gt; collection(&quot;character&quot;) |&gt; term(&quot;name.first&quot;, &quot;Snowful&quot;) |&gt; show([&quot;character_id&quot;, &quot;faction_id&quot;]) |&gt; join(online_status_join)TreesYou can organize the returned data by a field within the data, using the QueryBuilder.tree/2.import PS2.API.QueryBuilder alias PS2.API.{Query, Tree} %Query{} |&gt; collection(&quot;world_event&quot;) |&gt; term(&quot;type&quot;, &quot;METAGAME&quot;) |&gt; lang(&quot;en&quot;) |&gt; tree( %Tree{} |&gt; field(&quot;world_id&quot;) |&gt; list(true) )","ref":"PS2.API.QueryBuilder.html","title":"PS2.API.QueryBuilder","type":"module"},{"doc":"Adds a c:case (sensitivity) term. Overwrites previous params of the same name.API Documentation:Set whether a search should be case-sensitive, true means case-sensitive. true is the default. Note that using this command may slow down your queries. If a lower case version of a field is available use that instead for faster performance.","ref":"PS2.API.QueryBuilder.html#case_sensitive/2","title":"PS2.API.QueryBuilder.case_sensitive/2","type":"function"},{"doc":"Set the collection of the query/join.","ref":"PS2.API.QueryBuilder.html#collection/2","title":"PS2.API.QueryBuilder.collection/2","type":"function"},{"doc":"Adds a c:distinct term. Overwrites previous params of the same name.API Documentation:Get the distinct values of the given field. For example to get the distinct values of ps2.item.max_stack_size use http://census.daybreakgames.com/get/ps2/item?c:distinct=max_stack_size. Results are capped at 20,000 values.","ref":"PS2.API.QueryBuilder.html#distinct/2","title":"PS2.API.QueryBuilder.distinct/2","type":"function"},{"doc":"Adds a c:exactMatchFirst term. Overwrites previous params of the same name.API Documentation:When using a regex search (=^ or =*) c:exactMatchFirst=true will cause exact matches of the regex value to appear at the top of the result list despite the value of c:sort.","ref":"PS2.API.QueryBuilder.html#exact_match_first/2","title":"PS2.API.QueryBuilder.exact_match_first/2","type":"function"},{"doc":"Adds a field: term.API Documentation:The field to remove and use as in the data structure, or tree.","ref":"PS2.API.QueryBuilder.html#field/2","title":"PS2.API.QueryBuilder.field/2","type":"function"},{"doc":"Adds a c:has term. Overwrites previous params of the same name.API Documentation:Include objects where the specified field exists, regardless of the value within that field.","ref":"PS2.API.QueryBuilder.html#has/2","title":"PS2.API.QueryBuilder.has/2","type":"function"},{"doc":"Adds a c:hide term. Overwrites previous params of the same name.API Documentation:Include all field except the provided fields from the object within the result.","ref":"PS2.API.QueryBuilder.html#hide/2","title":"PS2.API.QueryBuilder.hide/2","type":"function"},{"doc":"Adds a c:includeNull term. Overwrites previous params of the same name.API Documentation:Include NULL values in the result. By default this is false. For example, if the name.fr field of a vehicle is NULL the field name.fr will not be included in the response by default. Add the c:includeNull=true command if you want the value name.fr : NULL to be returned in the result.","ref":"PS2.API.QueryBuilder.html#include_null/2","title":"PS2.API.QueryBuilder.include_null/2","type":"function"},{"doc":"Adds an injected_at: term. field is the name of the new field where the result of the join is inserted.API Documentation:The field name where the joined data should be injected into the returned document.","ref":"PS2.API.QueryBuilder.html#inject_at/2","title":"PS2.API.QueryBuilder.inject_at/2","type":"function"},{"doc":"Adds a join to a query. See the &quot;Using c:join to join collections dynamically&quot; section at https://census.daybreakgames.com/#query-commands to learn more about joining queries.c:join API Documentation:Meant to replace c:resolve, useful for dynamically joining (resolving) multiple data types in one query.","ref":"PS2.API.QueryBuilder.html#join/2","title":"PS2.API.QueryBuilder.join/2","type":"function"},{"doc":"Adds a c:lang term. Overwrites previous params of the same name.API Documentation:For internationalized strings, remove all translations except the one specified.","ref":"PS2.API.QueryBuilder.html#lang/2","title":"PS2.API.QueryBuilder.lang/2","type":"function"},{"doc":"Adds a c:limit term. Overwrites previous params of the same name.API Documentation:Limit the results to at most N [value] objects.","ref":"PS2.API.QueryBuilder.html#limit/2","title":"PS2.API.QueryBuilder.limit/2","type":"function"},{"doc":"Adds a c:limitPerDB term. Overwrites previous params of the same name.API Documentation:Limit the results to at most (N * number of databases) objects.*The data type ps2/character is distributed randomly across 20 databases. Using c:limitPerDb will have more predictable results on ps2/character than c:limit will.","ref":"PS2.API.QueryBuilder.html#limit_per_db/2","title":"PS2.API.QueryBuilder.limit_per_db/2","type":"function"},{"doc":"Adds a sort term (to a Join or Tree). Specifies whether the result should be a list (true) or a single record (false). Defaults to false.","ref":"PS2.API.QueryBuilder.html#list/2","title":"PS2.API.QueryBuilder.list/2","type":"function"},{"doc":"Adds an on: term. field is the field on the parent/leading collection to compare with the join's field (optionally specified with the to/2 function).API Documentation:The field on this type to join on, i.e. item_id. Will default to {this_type}_id or {other_type}_id if not provided.","ref":"PS2.API.QueryBuilder.html#on/2","title":"PS2.API.QueryBuilder.on/2","type":"function"},{"doc":"Adds an outer: term. Note: where the API docs specify 1, true should be passed, and false in place of 0.API Documentation:1 if you wish to do an outer join (include non-matches), 0 if you wish to do an inner join (exclude non-matches). Defaults to 1- do an outer join, include non-matches.","ref":"PS2.API.QueryBuilder.html#outer/2","title":"PS2.API.QueryBuilder.outer/2","type":"function"},{"doc":"Add a prefix: term.API Documentation:A prefix to add to the field value to make it more readable. For example, if the field is &quot;factionid&quot; and prefix is &quot;f&quot;, path will be f_1, f_2, f_3 etc.","ref":"PS2.API.QueryBuilder.html#prefix/2","title":"PS2.API.QueryBuilder.prefix/2","type":"function"},{"doc":"Adds a c:resolve term. Overwrites previous params of the same name. Note that join/3 is recommended over resolve/2, as resolve relies on supported collections to work.API Documentation:&quot;Resolve&quot; information by merging data from another collection and include the detailed object information for the provided fields from the object within the result (multiple field names separated by a comma).*Please note that the resolve will only function if the initial query contains the field to be resolved on. For instance, resolving leader on outfit requires that leader_character_id be in the initial query.","ref":"PS2.API.QueryBuilder.html#resolve/2","title":"PS2.API.QueryBuilder.resolve/2","type":"function"},{"doc":"Adds a c:retry term. Overwrites previous params of the same name.API Documentation:If true, query will be retried one time. Default value is true. If you prefer your query to fail quickly pass c:retry=false.","ref":"PS2.API.QueryBuilder.html#retry/2","title":"PS2.API.QueryBuilder.retry/2","type":"function"},{"doc":"Adds a c:show term. Overwrites previous params of the same name.API Documentation:Only include the provided fields from the object within the result.","ref":"PS2.API.QueryBuilder.html#show/2","title":"PS2.API.QueryBuilder.show/2","type":"function"},{"doc":"Adds a c:sort term. Overwrites previous params of the same name.API Documentation:Sort the results by the field(s) provided.","ref":"PS2.API.QueryBuilder.html#sort/2","title":"PS2.API.QueryBuilder.sort/2","type":"function"},{"doc":"Adds a c:start term. Overwrites previous params of the same name.API Documentation:Start with the Nth object within the results of the query.*Please note that c:start will have unusual behavior when querying ps2/character which is distributed randomly across 20 databases.","ref":"PS2.API.QueryBuilder.html#start/2","title":"PS2.API.QueryBuilder.start/2","type":"function"},{"doc":"Adds a start: term.API Documentaion:Used to tell the tree where to start. By default, the list of objects at the root will be formatted as a tree.","ref":"PS2.API.QueryBuilder.html#start_field/2","title":"PS2.API.QueryBuilder.start_field/2","type":"function"},{"doc":"Add a term to filter query results. i.e. filter a query by character ID: .../character?character_id=1234123412341234123","ref":"PS2.API.QueryBuilder.html#term/4","title":"PS2.API.QueryBuilder.term/4","type":"function"},{"doc":"Adds a c:timing term. Overwrites previous params of the same name.API Documentation:Shows the time taken by the involved server-side queries and resolves.","ref":"PS2.API.QueryBuilder.html#timing/2","title":"PS2.API.QueryBuilder.timing/2","type":"function"},{"doc":"Adds a to: term. field is the field on the joined collection to compare with the parent/leading field (optionally specified with the on/2 function).API Documentation:The field on the joined type to join to, i.e. attachment_item_id. Will default to on if on is provide, otherwise will default to {this_type}_id or {other_type}_id if not provided.","ref":"PS2.API.QueryBuilder.html#to/2","title":"PS2.API.QueryBuilder.to/2","type":"function"},{"doc":"Adds a c:tree termAPI Documentaion:Useful for rearranging lists of data into trees of data. See below for details.","ref":"PS2.API.QueryBuilder.html#tree/2","title":"PS2.API.QueryBuilder.tree/2","type":"function"},{"doc":"","ref":"PS2.API.QueryBuilder.html#t:collection_name/0","title":"PS2.API.QueryBuilder.collection_name/0","type":"type"},{"doc":"","ref":"PS2.API.QueryBuilder.html#t:field_name/0","title":"PS2.API.QueryBuilder.field_name/0","type":"type"},{"doc":"","ref":"PS2.API.QueryBuilder.html#t:modifer/0","title":"PS2.API.QueryBuilder.modifer/0","type":"type"},{"doc":"","ref":"PS2.API.QueryResult.html","title":"PS2.API.QueryResult","type":"module"},{"doc":"","ref":"PS2.API.QueryResult.html#t:t/0","title":"PS2.API.QueryResult.t/0","type":"type"},{"doc":"A data structure representing a tree on an API query. Create a tree using %PS2.API.Tree{} or the new/0 or new/1 functions.","ref":"PS2.API.Tree.html","title":"PS2.API.Tree","type":"module"},{"doc":"","ref":"PS2.API.Tree.html#new/1","title":"PS2.API.Tree.new/1","type":"function"},{"doc":"","ref":"PS2.API.Tree.html#t:opts/0","title":"PS2.API.Tree.opts/0","type":"type"},{"doc":"","ref":"PS2.API.Tree.html#t:t/0","title":"PS2.API.Tree.t/0","type":"type"},{"doc":"","ref":"PS2.API.Tree.html#t:terms/0","title":"PS2.API.Tree.terms/0","type":"type"},{"doc":"A module that handles all interaction with Daybreak Games' Planetside 2 Event Streaming service.ImplementationTo handle incoming game events, your module should use PS2.SocketClient and call PS2.SocketClient.start_link/2, passing the desired subscription info (Example implementation below). Events will now be sent to your SocketClient, which you handle though handle_event/1. Note that you should have a catch-all handle_event/1 callback in the case of unhandled events (see example), otherwise the client will crash whenever it receives an unhandled event.Example implementation:defmodule MyApp.EventStream do use PS2.SocketClient def start_link do subscriptions = [ events: [&quot;PlayerLogin&quot;], worlds: [&quot;Connery&quot;, &quot;Miller&quot;, &quot;Soltech&quot;], characters: [&quot;all&quot;] ] PS2.SocketClient.start_link(__MODULE__, subscriptions) end @impl PS2.SocketClient def handle_event({&quot;PlayerLogin&quot;, payload}) do IO.puts &quot;PlayerLogin: \#{payload[&quot;character_id&quot;]}&quot; end # Catch-all callback. @impl PS2.SocketClient def handle_event({event_name, _payload}) do IO.puts &quot;Unhandled event: \#{event_name}&quot; end endThe second param of PS2.SocketClient.start_link/2 is the subscription info your client is interested in. See the link below to find a list of all event names. You may also specify &quot;all&quot; in any of the subscription fields (Note: if a field is missing, &quot;all&quot; will be the default.) If you want to receive heartbeat messages (which contain world status updates), include &quot;heartbeat&quot; in your event subscriptions.For more information, see the official documentation: https://census.daybreakgames.com/#websocket-details","ref":"PS2.SocketClient.html","title":"PS2.SocketClient","type":"behaviour"},{"doc":"","ref":"PS2.SocketClient.html#child_spec/1","title":"PS2.SocketClient.child_spec/1","type":"function"},{"doc":"","ref":"PS2.SocketClient.html#c:handle_event/1","title":"PS2.SocketClient.handle_event/1","type":"callback"},{"doc":"Starts the client process, subscribing to the event stream and listens for relevant events.","ref":"PS2.SocketClient.html#start_link/2","title":"PS2.SocketClient.start_link/2","type":"function"},{"doc":"A two-element tuple representing an in-game event.The first element is the event name (String), and the second element is the event payload (Map). Example: {&quot;VehicleDestroy&quot;, %{attacker_character_id: &quot;5428812948092239617&quot;, ... }}For a list of example payloads, see Daybreak's documentation: https://census.daybreakgames.com/#websocket-details","ref":"PS2.SocketClient.html#t:event/0","title":"PS2.SocketClient.event/0","type":"type"},{"doc":"An element in a keyword list where the key is either :events, :worlds, or :characters, and the value is a list of event names, world names, or character IDs with respect to the key.","ref":"PS2.SocketClient.html#t:subscription/0","title":"PS2.SocketClient.subscription/0","type":"type"},{"doc":"A list of subscriptions.","ref":"PS2.SocketClient.html#t:subscription_list/0","title":"PS2.SocketClient.subscription_list/0","type":"type"}]